hdu 2489 Minimal Ratio Tree DFS枚举点+最小生成树 属于中等偏上题 ,Double比较大小的时候注意精度问题

来源:互联网 发布:mac电影下载软件 编辑:程序博客网 时间:2024/05/04 07:03

Minimal Ratio Tree

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 2835    Accepted Submission(s): 841


Problem Description
For a tree, which nodes and edges are all weighted, the ratio of it is calculated according to the following equation.




Given a complete graph of n nodes with all nodes and edges weighted, your task is to find a tree, which is a sub-graph of the original graph, with m nodes and whose ratio is the smallest among all the trees of m nodes in the graph.
 

Input
Input contains multiple test cases. The first line of each test case contains two integers n (2<=n<=15) and m (2<=m<=n), which stands for the number of nodes in the graph and the number of nodes in the minimal ratio tree. Two zeros end the input. The next line contains n numbers which stand for the weight of each node. The following n lines contain a diagonally symmetrical n×n connectivity matrix with each element shows the weight of the edge connecting one node with another. Of course, the diagonal will be all 0, since there is no edge connecting a node with itself.



All the weights of both nodes and edges (except for the ones on the diagonal of the matrix) are integers and in the range of [1, 100].

The figure below illustrates the first test case in sample input. Node 1 and Node 3 form the minimal ratio tree.

 

Output
For each test case output one line contains a sequence of the m nodes which constructs the minimal ratio tree. Nodes should be arranged in ascending order. If there are several such sequences, pick the one which has the smallest node number; if there's a tie, look at the second smallest node number, etc. Please note that the nodes are numbered from 1 .
 

Sample Input
3 230 20 100 6 26 0 32 3 02 21 10 22 00 0
 

Sample Output
1 31 2

转载请申明: http://blog.csdn.net/lionel_d

写代码的时候,,总是犯SB的错误!!!导致wrong了好长时间!!一直以为是精度错了,,o(╯□╰)o
先枚举m个 点,,再求这m个点的最小生成树,,就可以了,,一开始我是先求n个点的最小生成树,再从树上枚举m个点,,,结果老是wrong,后来看别人的题解,,才明白自己的思路错了很严重啊!!!

看代码:
#include <cstdio>#include <cstring>#include <algorithm>#define MAX 20#define INF 100000000using namespace std ;int graph[MAX][MAX] , lowCost[MAX] , node[MAX] , path[MAX] , temp[MAX];int n ,m ;bool cmp(const int a , const int b){return a<b ;}int prim(int s){bool visited[MAX] ;memset(visited,false,sizeof(visited)) ;int sum = 0 ;for(int i = 0 ; i < m ; ++i){lowCost[temp[i]] = graph[s][temp[i]] ;}visited[s] = true ;for(int i = 0 ; i < m-1 ; ++i){int min = INF , index = -1 ;for(int j = 0 ; j < m ; ++j){if(!visited[temp[j]] && lowCost[temp[j]]<min){min = lowCost[temp[j]] ;index = temp[j] ;}}if(index == -1){break ;}visited[index] = true ;sum += min ;for(int j = 0 ; j < m ; ++j){if(!visited[temp[j]] && lowCost[temp[j]]>graph[index][temp[j]]){lowCost[temp[j]] = graph[index][temp[j]] ;}}}return sum ;}double ans = INF*1.0 ;void DFS(int num , int count){if(count == m){int sumOfEdge = prim(temp[0]) ,sumOfNode = 0;for(int i = 0 ; i < m ; ++i){sumOfNode += node[temp[i]] ;}double t = sumOfEdge*1.0/sumOfNode ;if(ans-t>0.00001){ans = t ;for(int i = 0 ; i < m ; ++i){path[i] = temp[i] ;}}return ;}for(int i = num+1 ; i <= n ; ++i){temp[count] = i ;DFS(i,count+1);}}int main(){while(~scanf("%d%d",&n,&m) && (m||n)){for(int i = 1 ; i <= n ; ++i){scanf("%d",&node[i]) ;}for(int i = 1 ;i <= n ; ++i ){for(int j = 1 ; j <= n ; ++j){scanf("%d",&graph[i][j]) ;}graph[i][i] = INF ;}ans = INF*1.0 ;for(int i = 1 ; i <= n ; ++i){temp[0] = i ;DFS(i,1);}sort(path,path+m,cmp) ;for(int i = 0 ; i < m ; ++i){printf("%d",path[i]) ;if(i != m-1){printf(" ") ;}}puts("") ;}return 0 ;}

与君共勉
0 0
原创粉丝点击